//
//  MLViewController+Action.swift
//  memoList
//
//  Created by narita on 2019/04/21.
//  Copyright © 2019 narita. All rights reserved.
//

import Foundation
import Cocoa

extension MLViewController
{
    // MARK: - class methods
    
    // MARK: - init methods
    
    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods
    
    // MARK: - action methods
    
    @IBAction func copy(_ sender: Any?)
    {
        if let theSelectedObjects = arrayController.selectedObjects as? [Memo]
        {
            if !theSelectedObjects.isEmpty
            {
                NSPasteboard.general.clearContents()
                
                NSPasteboard.general.setPropertyList(theSelectedObjects.map{ $0.toPlist() },
                                                     forType: .memoListMemoPasteboardType)
            }
        }
    }
    
    @IBAction func paste(_ sender: Any?)
    {
        if let theObject = NSPasteboard.general.propertyList(forType: .memoListMemoPasteboardType)
        {
            if let thePlistArray = theObject as? [NSDictionary]
            {
                let theMemos = thePlistArray.map
                {
                    Memo(context: arrayController.managedObjectContext!, plist: $0)
                }
                
                arrayController.insert(contentsOf: theMemos,
                                       atArrangedObjectIndexes: IndexSet(integer: arrayController.indexForInsertion()))
                
            }
        }
    }
    
    @IBAction func cut(_ sender: Any?)
    {
        self.copy(sender)
        self.delete(sender)
    }
    
    @IBAction func delete(_ sender: Any?)
    {
        arrayController.remove(sender)
    }
    
    @IBAction func addItem(_ sender: Any?)
    {
        // arrayController.add(sender) // 末尾に追加
        arrayController.insert(sender) // 選択箇所に追加。少し場所がおかしい気がする。
        
    }
    
    @IBAction func removeItem(_ sender: Any?)
    {
        arrayController.remove(sender)
    }
        
    // MARK: - accessor methods (in pairs)
    
    // MARK: - Utility methods
    
}
