//
//  MLViewController+DnD.swift
//  memoList
//
//  Created by narita on 2019/04/21.
//  Copyright © 2019 narita. All rights reserved.
//

import Foundation
import Cocoa

extension MLViewController
{
    // MARK: - class methods
    
    // MARK: - init methods
    
    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods
    
    // MARK: - action methods
    
    // MARK: - NSTableViewDelegate & NSTableViewDataSource
    
    @objc func setupDragAndDrop()
    {
        self.tableView!.registerForDraggedTypes([.memoListMemoPasteboardType])
        self.tableView!.setDraggingSourceOperationMask([.copy, .move], forLocal: true)
        self.tableView!.draggingDestinationFeedbackStyle = .regular
    }
    
    @objc func tableView(_ tableView: NSTableView, writeRowsWith rowIndexes: IndexSet, to pboard: NSPasteboard) -> Bool
    {
        // ToDo: selectedObjectsはドラッグするものではないが、面倒なのでだいたい同じとみなしてます。
        
        if let theSelectedObjects = arrayController.selectedObjects as? [Memo]
        {
            if !theSelectedObjects.isEmpty
            {
                let thePB = NSPasteboard(name: .drag)
                thePB.clearContents()
                
                thePB.setPropertyList(theSelectedObjects.map{ $0.toPlist() },
                                                     forType: .memoListMemoPasteboardType)
            }
            
            return true
        }
        
        return false
    }
    
    @objc func tableView(_ tableView: NSTableView,
                         validateDrop info: NSDraggingInfo,
                         proposedRow row: Int,
                         proposedDropOperation dropOperation: NSTableView.DropOperation) -> NSDragOperation
    {
        var theResult: NSDragOperation = []
        
        if dropOperation == .above
        {
            let theSRC = tableView.window?.windowController?.document as! NSDocument
            let theDST = self.tableView!.window?.windowController?.document as! NSDocument
            
            if theSRC == theDST
            {
                theResult = .move
            }
            else
            {
                theResult = .copy
            }
        }
        
        return theResult
    }
    
    @objc func tableView(_ tableView: NSTableView,
                         acceptDrop info: NSDraggingInfo,
                         row: Int,
                         dropOperation: NSTableView.DropOperation) -> Bool
    {
        let thePB = info.draggingPasteboard
        let theArray = thePB.propertyList(forType: .memoListMemoPasteboardType) as! [NSDictionary]
        
        if info.draggingSourceOperationMask.contains(.move)
        {
            let theSelectedObjects = arrayController.selectedObjects as! [Memo]
            
            arrayController.insert(contentsOf: theArray.map{Memo(context: arrayController.managedObjectContext!, plist: $0)},
                                   atArrangedObjectIndexes: IndexSet(integer: row))

            arrayController.remove(contentsOf: theSelectedObjects)
            
            return true
        }
        else if info.draggingSourceOperationMask.contains(.copy)
        {
            arrayController.insert(contentsOf: theArray.map{Memo(context: arrayController.managedObjectContext!, plist: $0)},
                                   atArrangedObjectIndexes: IndexSet(integer: row))
            
            return true
        }

        return false
    }
    
    // MARK: - accessor methods (in pairs)
    
    // MARK: - Utility methods
    
}
