//
//  Memo+CoreDataClass.swift
//  memoList
//
//  Created by narita on 2019/04/21.
//  Copyright © 2019 narita. All rights reserved.
//
//

import Foundation
import CoreData
import Cocoa


extension NSPasteboard.PasteboardType
{
    public static let memoListMemoPasteboardType = NSPasteboard.PasteboardType("com.mindto01s.memoList.Memo")
}


@objc(Memo)
public class Memo: NSManagedObject//, NSPasteboardWriting
{
    // MARK: - イニシャライザ (mocが必要なためにNSPasteboardReadingには出来ない)
    
    public convenience init(context moc: NSManagedObjectContext, plist: NSDictionary?)
    {
        self.init(context: moc)
        
        if let theDict = plist?.dictionaryWithValues(forKeys: Array(self.entity.attributesByName.keys))
        {
            // 余計な値をkey/Valueで渡さないように、CoreDataの定義からattributesNameを引っ張って来ている
            self.setValuesForKeys(theDict)
        }
    }
    
    // MARK: - NSPasteboardWritingにしなくてもいいや
    
//    @objc public func writableTypes(for pasteboard: NSPasteboard) -> [NSPasteboard.PasteboardType]
//    {
//        return [ .memoListMemoPasteboardType ]
//    }
//
//    @objc public func pasteboardPropertyList(forType type: NSPasteboard.PasteboardType) -> Any?
//    {
//        switch type
//        {
//            case .memoListMemoPasteboardType:
//                return self.toPlist()
//
//            default:
//                return nil
//        }
//    }
    
    @objc public func toPlist() -> Any?
    {
        return self.dictionaryWithValues(forKeys: Array(self.entity.attributesByName.keys))
    }
}
